<?php

include '../../core.php';

checkAuth($raUrl);

cabecera (2);

// El siguiente script se encarga de comprobar que los datos
// de un formulario son validos antes de enviarlos.
echo "<script type='text/javascript'>
<!--
function submit_form()
{
  if ( document.crr_form.crrID.value == ''  ||
       document.crr_form.crrID.value.search(/[^a-z,A-Z,0-9,\.,_,\@,\/,\-]/i) >= 0)
  {
    alert ('Por favor introduzca un Identificador correcto. Solo puede escribir caracteres de la \'a\' a la \'z\', números y signos\'/\', \'.\', \'-\' y \'_\'');
    document.crr_form.crrID.focus();
    return false;
  }
  document.crr_form.submit();
  return true;
}
// -->
</script>\n";

// En la variable command guardaremos el estado de la revocacion.
// Dependiendo de su valor, entraremos en una u otra parte del codigo.
$command = $_POST["crr_command"];
$status = "revoke";

switch($command) {
   
   // Por defecto mostramos el formulario en el que se le solicita
   // al usuario los datos del certificado a revocar   
   default:
      echo "<h1 class='title'>Solicitud de Revocaci&oacute;n de Certificado</h1>
      <form method='post' action='crr.php' enctype='multipart/form-data' name='crr_form'>
        <table class='box' border='0' cellpadding='1' cellspacing='1'>
        <tr>
          <td>Identificador</td>
          <td><input class='form_input' type='text' name='crrID'  size='25' /></td>
        </tr>
        <tr>
          <td>C&oacute;digo de solicitud</td>
          <td><input class='cajaTexto' type='text' name='copa'  size='16' /></td>
        </tr>
       <tr>
          <td>Motivo de la revocaci&oacute;n</td>
          <td><select name='revReason'>";
             while (list (,$content) = each ($revReasons)) {
                echo "<option>$content</option>";
             }
          echo "</select>
          </td>
       </tr>
       <tr>
          <td>Comentarios (opcional)</td>
	  <td><input type='text' name='comments'  size='25'></td>
       </tr>				  
       </table>
       <input type='hidden' name='crr_command' value='crr_process'>
       <p><input type='button' value='Continuar' onclick='submit_form()' /></p>
       </form>\n";
      break;

      
   case "crr_process":
      $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
      $justthese = array("cn", "sn", "pkirisID");
      $result = ldap_get_info($base, $filter, $justthese);
     
      // Verificamos si existe el codigo del certificado, si el resultado del count($result) es 1 no existe, si es 2 si existe.
      if (count($result) == 1) {	   
	 $errorNumber = 69;
	 $errorCounter++;
	 $errorDescription = "\n<p>El c&oacute;digo que ha introducido no se corresponde con ning&uacute;n certificado.</>\n";
      }
      // Si existe, tenemos que comprobar si el identificador introducido se corresponde con ese codigo
      else {  
	 if ($result[0]["pkirisid"][0] != $crrID ) {
	    $errorNumber = 69;
            $errorCounter++;
	    $errorDescription = "\n<p>El c&oacute;digo de solicitud que ha introducido no tiene ese identificador asociado. Por tanto no puede pedir una revocaci&oacute;n</>\n";
	 }

         else {
	          
            // Buscamos la informacion del certificado que tenga el usuario
	    // en estado 'issued'
            $filter2 = "(&(objectClass=pkirisCertificate)(pkirisStatus=issued)(pkirisCopaID=$copa))";
            $justthese = array("dn", "pkiriscerttype", "pkirispin");
  
            $result2 = ldap_get_info($base, $filter2, $justthese);
      
            if (count($result2) == 1) {
	       $errorNumber = 69;
               $errorCounter++;
               $errorDescription = "\n<p>El identificador que ha introducido no tiene ning&uacute;n certifiado firmado. Por tanto no puede pedir una revocaci&oacute;n</>\n";
            }
            else {
               // Obtenemos el Certificado del usuario, lo pasamos a un archivo
	       // como .der y luego lo pasamos a .txt
               $userCert = ldap_get_cert($base, $filter2);

	       // Si ha habido algun error, mostramos mensaje y no continuamos
               if (!$userCert){
		  $errorNumber = 69;
                  $errorCounter++;
		  $errorDescription = "\n<p>No se ha podido obtener el certificado.</>\n";		  
               }

	       else {
		       
	          list ($userCopa, $kk) = split ("c", $copa);
  	          $filter = "(&(objectClass=pkirisEndEntity)(pkirisCopaID=$userCopa))";
 	          $justthese = array("cn", "sn");
  	          $result3 = ldap_get_info($base, $filter, $justthese);

	          $cn = $result3[0]["cn"][0];
                  $sn = $result3[0]["sn"][0];
                  $type = $result2[0]["pkiriscerttype"][0];
                  $dn = $result2[0]["dn"];
  
                  echo "<h3>Datos sobre la solicitud de Revocaci&oacute;n (CRR)</h3>
                  <br />
                  <table border='1' cellpadding='2' cellspacing='0'>
                  <tr><td>Identificador</td><td>$crrID</td></tr>
                  <tr><td>C&oacute;digo de solicitud</td><td>$copa</td></tr>
                  <tr><td>Nombre</td><td>" . $cn . " " . $sn ."</td></tr>";
 
                  if ($type == "srv") {
                     echo "<tr><td>Tipo</td><td>Certificado de Servidor</td></tr>";
                  } 
                  else {
                     echo "<tr><td>Tipo</td><td>Certificado de Usuario</td></tr>";
                  }
                  echo "</table>
                  <br />
                  <h3>Datos sobre el certificado que se va a revocar</h3> 
                  <PRE>\n";

                  $derFile = $crtData . $copa.".x509ee";
                  // Verificamos si existe el fichero y si no lo creamos y volcamos la info del certificado en el
                  if (!file_exists($filename)) {
                     $der = fopen($derFile, "w");
                     fputs($der, $userCert[0]);
                     fclose($der);
                  }

                  $txtCert = exec($binOpenssl . " x509 -text -inform DER < " .$derFile, $result);
         
                  for($i = 1; $i < count($result); $i++) {
                     echo "$result[$i]\n"; 
                   }
                  
		   echo "</PRE>
                      <form method='post' action='crr.php'>
                      <input class='form_submit' type=submit value='Generar petici&oacute;n de revocaci&oacute;n'>
		      <input type='hidden' name='crr_id' value='$crrID'>
		      <input type='hidden' name='copa' value='$copa'>
                      <input type='hidden' name='dn' value='$dn'>
   		      <input type='hidden' name='errorNumber'  value='$errorNumber'>
		      <input type='hidden' name='comments'  value='$comments'>
		      <input type='hidden' name='crr_reason' value='$revReason'>
                      <input type='hidden' name='crr_command' value='crr_makeXml'>
                      </form>\n";
		        
	       }
            }
         }
      }  
              
      if ( $errorCounter != 0 )
         echo "<h3> Error en la Solicitud de Revocaci&oacute;n </h3>" . $errorDescription;		  
      
      break;

   case "crr_makeXml":
    
      $lastStatus = getStatus($copa);
      // Esta comprobacion se hace para evitar que se escriba dos veces la
      // misma traza y el mismo xml al recargar el navegador
      if ($lastStatus == "issued") {
         
         $currentDate = date("YmdHis");
         $invalidityDate = $currentDate; // En un futuro, esta variable debe tener otro valor
	    
         $traceVals["status"] = $status;
         $traceVals["copa"] = $copa;
         $traceVals["currentDate"] = $currentDate;
         $traceVals["invalidityDate"] = $invalidityDate;
         $traceVals["revocationReason"] = $crr_reason;
         $traceVals["comments"] = $comments;
     
         // Construimos la urn con los valores especificados en $traceVals
         $pkiTrace =  getTrace ($traceVals);

	 // Necesitamos saber el numero copa del administrador de la RA para
	 // meterlo en el fichero XML y saber quien solicito la revocacion
         $subjectDN = getDn();
	 $adminCopa = getUserCopaFromDN($subjectDN);
            
	 // Cambiamos los estados de pkiStatus, pkiDate y pkiRevocationReason
         $updateFields["pkirisstatus"] = $status;
         $updateFields["pkirisdate"] = $currentDate;
         $updateFields["pkirisrevocationreason"] = $crr_reason;
	 $updateFields["pkirisrevokedbycopaid"] = $adminCopa;

	 $r=ldap_mod_info($dn, $updateFields);

         if (!$r) {
            $errorNumber = 69;
	    $errorCounter++;
	    $errorDescription = "\n<p>No se ha podido modificar la informacion del ldap</p>\n";
	 }
	 else {
	    // Insertamos la traza en ldap
	    $urn["pkiristrace"] = $pkiTrace;
	    $r=ldap_mod_add_info($dn, $urn);
  
  	    if (!$r) {
               $errorNumber = 69;
               $errorCounter++;
	       $errorDescription = "\n<p>No se ha podido modificar la informacion del ldap</p>\n";
	    }
	 }

         // Si no ha habido errores, generarmos el fichero XML para enviar los
         // datos a la CA
  	 if ($errorCounter == 0 ) {
            $r = createXML ( array($copa) );
    
            if (!$r) {
               $errorNumber = 69;
	       $errorCounter++;
	       $errorDescription = "\n<p>No ha sido posible generar el fichero XML.</p>\n";	       
	    }
	 }
      }
      else{
         $errorNumber = 69;
         $errorCounter++;
	 $errorDescription = "\n<p>Su solicitud ya ha sido procesada anteriormente. Tiene el estado $lastStatus</p>";
      }

      if ( $errorCounter == 0 ) 
         echo "<h1 class='title'>Solicitud de Revocaci&oacute;n</h1><h3> Solicitud Aceptada </h3>
               <p> Su solicitud de revocaci&oacute;n ha sido aceptada y sera enviada de inmediato al administrador de la CA para revocar el certificado indicado.</p>";
      else
         echo "<h3> Error en la Solicitud de Revocaci&oacute;n </h3>" . $errorDescription;
     
      // Obtenemos el pkirisCopaID a partir de pkirisSubjectID
      $userDN = $_SESSION['user'];
      $filter = "(&(objectClass=pkirisCertificate)(pkirisSubjectDn=$userDN)(pkirisStatus=issued))";
      $justthese = array("pkirisCopaID");
      $result = ldap_get_info($base, $filter, $justthese);

      $user = $result[0]['pkiriscopaid'][0];
      
      // Escribimos en el fichero de log los cambios de estado realizados
      writeLog ($status, $copa, $user, $errorNumber);
	
      break;   
}

pie ();

?>
